/*
 * Copyright 2011 Steven Gribble
 *
 *  This file is part of the UW CSE 333 course project sequence
 *  (333proj).
 *
 *  333proj is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  333proj is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with 333proj.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <map>
#include <string>
#include <vector>

#include "./HttpRequest.h"
#include "./HttpUtils.h"
#include "./HttpConnection.h"

using std::map;
using std::string;

namespace hw3 {

bool HttpConnection::GetNextRequest(HttpRequest *request) {
  // STEP 1.  Implement GetNextRequest().
  //
  // We recommend that you break this down into a few pieces.
  //
  // (a) Use WrappedRead() to read data from the socket into the
  // buffer_ instance variable.  After each successful read, test
  // to see if you have seen the end of a request (i.e., you've
  // seen a "\r\n\r\n" string).  Remember that you might actually
  // see more than one request at a time coming into the connection,
  // so you will need to preserve the data after the \r\n\r\n in
  // the buffer_ variable for the next time the customer calls
  // GetNextRequest.
  //
  // (b) Implement a helper function that takes a string that contains
  // a full HTTP request and returns a parsed HttpRequest object.
  // The hard part here is parsing the HTTP headers into the header
  // map.  (One finicky thing: remember to convert the header name
  // into lower case here, just to make it easier for customers to
  // find particular headers.)
  //
  // (c) Splice out the request that you parsed from buffer_, leaving
  // any data leftover for the next invocation of GetNextRequest.
  return true;
}

bool HttpConnection::WriteResponse(const HttpResponse &response) {
  // STEP 2: implement WriteResponse().
  //
  // This is a simpler method than GetNextRequest: use your WrappedWrite
  // function, as well as the GenerateResponseString() method of
  // HttpResponse, to generate the response string and write it back
  // to the client.
  return true;
}

}  // namespace hw3
