/*
 * Copyright 2012 Steven Gribble
 *
 *  This file is part of the UW CSE333 project sequence (333proj12).
 *
 *  333proj12 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published
 *  by the Free Software Foundation, either version 3 of the License,
 *  or (at your option) any later version.
 *
 *  333proj12 is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with 333proj12.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _HW2_SOCKETCLIENT_H_
#define _HW2_SOCKETCLIENT_H_

#include <netdb.h>
#include <stdint.h>
#include <sys/socket.h>

#include <string>

// Do a DNS lookup on "hostname" using getaddrinfo to construct the
// appropriate struct sockaddr_storage, also filling in port
// "portnum".  The constructed structure and its length are returned
// through the return parameters "ret_addr" and "ret_addrlen".  If
// the DNS lookup results in multiple records, this routine uses
// the first one.
//
// Returns true on successful lookup, false otherwise.
bool DNSLookup(std::string hostname, uint16_t portnum,
               struct sockaddr_storage *ret_addr, size_t *ret_addrlen);

// Attempt to open a TCP stream connection to the server at DNS
// name "hostname" at port number "portnum".
//
// On success, returns a file descriptor >=0.  On failure, indicates
// error by returning a number <0.
int ConnectToServer(std::string hostname, uint16_t portnum);

#endif  // _HW2_SOCKETCLIENT_H_
